OGRE-Next: Ogre::IntersectionSceneQuery Class Reference

| OGRE-Next 3.0.0 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::IntersectionSceneQuery Class Referenceabstract
Core | Component » Scene

Separate SceneQuery class to query for pairs of objects which are possibly intersecting one another. More...

`#include <OgreSceneQuery.h>`

Inheritance diagram for Ogre::IntersectionSceneQuery:
[legend]

## Public Member Functions
| IntersectionSceneQuery (SceneManager *mgr)
| ~IntersectionSceneQuery () override
virtual void | clearResults ()
| Clears the results of the last query execution.
virtual IntersectionSceneQueryResult & | execute ()
| Executes the query, returning the results back in one list.
virtual void | execute (IntersectionSceneQueryListener *listener)=0
| Executes the query and returns each match through a listener interface.
virtual IntersectionSceneQueryResult & | getLastResults () const
| Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.
bool | queryResult (MovableObject *first, MovableObject *second) override
| Self-callback in order to deal with execute which returns collection.
bool | queryResult (MovableObject *movable, SceneQuery::WorldFragment *fragment) override
| Self-callback in order to deal with execute which returns collection.
Public Member Functions inherited from Ogre::SceneQuery
| SceneQuery (SceneManager *mgr)
| Standard constructor, should be called by SceneManager.
virtual | ~SceneQuery ()
virtual uint32 | getQueryMask () const
| Returns the current mask for this query.
virtual const set< WorldFragmentType >::type * | getSupportedWorldFragmentTypes () const
| Returns the types of world fragments this query supports.
virtual WorldFragmentType | getWorldFragmentType () const
| Gets the current world fragment types to be returned from the query.
virtual void | setQueryMask (uint32 mask)
| Sets the mask for results of this query.
virtual void | setWorldFragmentType (enum WorldFragmentType wft)
| Tells the query what kind of world geometry to return from queries; often the full renderable geometry is not what is needed.
Public Member Functions inherited from Ogre::IntersectionSceneQueryListener
virtual | ~IntersectionSceneQueryListener ()

## Additional Inherited Members
Public Types inherited from Ogre::SceneQuery
enum | WorldFragmentType { WFT_NONE , WFT_PLANE_BOUNDED_REGION , WFT_SINGLE_INTERSECTION , WFT_CUSTOM_GEOMETRY , WFT_RENDER_OPERATION }
| This type can be used by collaborating applications & SceneManagers to agree on the type of world geometry to be returned from queries. More...
Public Attributes inherited from Ogre::SceneQuery
uint8 | mFirstRq
uint8 | mLastRq

## Detailed Description

Separate SceneQuery class to query for pairs of objects which are possibly intersecting one another.

Remarks
  This SceneQuery subclass considers the whole world and returns pairs of objects which are close enough to each other that they may be intersecting. Because of this slightly different focus, the return types and listener interface are different for this class.

## Constructor & Destructor Documentation

## ◆ IntersectionSceneQuery()

Ogre::IntersectionSceneQuery::IntersectionSceneQuery | ( | SceneManager * | mgr | ) |

## ◆ ~IntersectionSceneQuery()

Ogre::IntersectionSceneQuery::~IntersectionSceneQuery | ( |  | ) |
| override

## Member Function Documentation

## ◆ clearResults()

virtual void Ogre::IntersectionSceneQuery::clearResults | ( |  | ) |
| virtual

Clears the results of the last query execution.

Remarks
  You only need to call this if you specifically want to free up the memory used by this object to hold the last query results. This object clears the results itself when executing and when destroying itself.

## ◆ execute() [1/2]

virtual IntersectionSceneQueryResult & Ogre::IntersectionSceneQuery::execute | ( |  | ) |
| virtual

Executes the query, returning the results back in one list.

Remarks
  This method executes the scene query as configured, gathers the results into one structure and returns a reference to that structure. These results will also persist in this query object until the next query is executed, or clearResults() is called. An more lightweight version of this method that returns results through a listener is also available.

## ◆ execute() [2/2]

virtual void Ogre::IntersectionSceneQuery::execute | ( | IntersectionSceneQueryListener * | listener | ) |
| pure virtual

Executes the query and returns each match through a listener interface.

Remarks
  Note that this method does not store the results of the query internally so does not update the 'last result' value. This means that this version of execute is more lightweight and therefore more efficient than the version which returns the results as a collection.

Implemented in Ogre::DefaultIntersectionSceneQuery.

## ◆ getLastResults()

virtual IntersectionSceneQueryResult & Ogre::IntersectionSceneQuery::getLastResults | ( |  | ) | const
| virtual

Gets the results of the last query that was run using this object, provided the query was executed using the collection-returning version of execute.

## ◆ queryResult() [1/2]

bool Ogre::IntersectionSceneQuery::queryResult | ( | MovableObject * | first,
|  | MovableObject * | second )
| overridevirtual

Self-callback in order to deal with execute which returns collection.

Implements Ogre::IntersectionSceneQueryListener.

## ◆ queryResult() [2/2]

bool Ogre::IntersectionSceneQuery::queryResult | ( | MovableObject * | movable,
|  | SceneQuery::WorldFragment * | fragment )
| overridevirtual

Self-callback in order to deal with execute which returns collection.

Implements Ogre::IntersectionSceneQueryListener.

The documentation for this class was generated from the following file:

- OgreSceneQuery.h